"
 COPYRIGHT (c) 2011 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libbasic' }"

Timestamp subclass:#UtcTimestamp
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Magnitude-Time'
!

!UtcTimestamp class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2011 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.

"
!

documentation
"
    This is a Timestamp, that represents itself as UTC.
    Internally it stores exactly the same value as Timestamp, 
    so the following experssion is always true:

        someTimestamp asUtcTimestamp = someTimestamp asLocalTimestamp

    But when printing, accessing hour, minute, ... and converting to Date and Time,
    it returns the values represented in the UTC zone instead of the local timezone.

    [author:]
        Stefan Vogel (stefan@zwerg.nil.exept.de)

    [instance variables:]

    [class variables:]

    [see also:]
        Time Date

"
! !

!UtcTimestamp methodsFor:'accessing'!

timeInfo
    ^ OperatingSystem computeUTCTimeAndDateFrom:osTime
!

timeZoneName
    ^ #utc
! !

!UtcTimestamp methodsFor:'converting'!

asLocalTimestamp
    "represent myself as a timestamp in the local timezone"

    ^ Timestamp fromOSTime:osTime
!

asUtcTimestamp
    "I am an UtcTimestamp"

    ^ self
! !

!UtcTimestamp methodsFor:'initialization'!

year:y month:m day:d hour:h minute:min second:s millisecond:millis 
    osTime := OperatingSystem 
                computeOSTimeFromUTCYear:y
                month:m
                day:d
                hour:h
                minute:min
                second:s
                millisecond:millis
! !

!UtcTimestamp methodsFor:'testing'!

isUtcTimestamp
    ^ true
! !

!UtcTimestamp methodsFor:'visiting'!

acceptVisitor:aVisitor with:aParameter
    ^ aVisitor visitUtcTimestamp:self with:aParameter
! !

!UtcTimestamp class methodsFor:'documentation'!

version_CVS
    ^ 'Header: /cvs/stx/stx/libbasic/UtcTimestamp.st,v 1.3 2011/01/24 17:58:33 stefan Exp '
!

version_SVN
    ^ '$Id: UtcTimestamp.st 10700 2011-09-29 15:44:37Z vranyj1 $'
! !
